﻿using System.Collections.Generic;

namespace Plux {
  public interface IAttributeDescriptor {
    string FieldName { get; }
    string ListCaption { get; }
    int Width { get; }
  }

  public class AttributeDescriptor : IAttributeDescriptor {
    public AttributeDescriptor() {
      Width = -1;
    }
    public string FieldName { get; set; }
    public string ListCaption { get; set; }
    public int Width { get; set; }
  }

  [SlotDefinition("Plux.Attribute")]
  public interface IAttributeProvider {
    IAttributeDescriptor KeyAttribute { get; }
    IAttributeDescriptor TitleAttribute { get; }
    IEnumerable<IAttributeDescriptor> SelectedAttributes { get; }
  }
}