﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Plux.Framework;

public partial class RestoreForm: Form {
	public RestoreForm()	{
		InitializeComponent();
    KeyPreview = true;
    KeyDown += SearchForm_KeyDown;
	}

  public RestoreForm(IEnumerable values) : this() {
    search.Items = values;
  }

  private void SearchForm_KeyDown(object sender, KeyEventArgs e) {
    switch (e.KeyCode) {
      case Keys.Enter:
        var sel = (CompositionRestorer.SavedCompilationInfo)this.SelectedItem;
        if (sel == null || sel.Root == null)
            return;
        DialogResult = DialogResult.OK;
        break;
      case Keys.Escape:
        DialogResult = DialogResult.Cancel;
        break;
      case Keys.Delete:
        var delSel = (CompositionRestorer.SavedCompilationInfo)this.SelectedItem;
        if (delSel != null)
        {
            int index = this.search.result.SelectedIndex;
            CompositionPersistor.DeleteFile(delSel.StoredFile);
            this.search.result.Items.Remove(delSel);
            if (this.search.result.Items.Count != 0)
            {
                if (index < this.search.result.Items.Count)
                    this.search.result.SelectedIndex = index;
                else
                    this.search.result.SelectedIndex = index - 1;
            }
        }
        break;
    }
    if (e.KeyCode == Keys.Escape || e.KeyCode == Keys.Enter) {
      Close();
      e.Handled = true;
    }
  }

  private void buttonOK_Click(object sender, EventArgs e)
  {
      if (this.SelectedItem != null)
      {
          DialogResult = DialogResult.OK;
          Close();
      }
  }

  private void buttonCancel_Click(object sender, EventArgs e)
  {
      DialogResult = DialogResult.Cancel;
      Close();
  }

  private void searchresult_SelectedValueChanged(object sender, EventArgs e)
  {
      var sel = (CompositionRestorer.SavedCompilationInfo)this.SelectedItem;
      if (sel != null)
      {
          if (sel.Root == null)
          {
              this.buttonOK.Enabled = false;
              this.label1.Text = "! Root Extension not found !";
          }
          else
          {
              this.buttonOK.Enabled = true;
              this.label1.Text = "";
          }
      }
  }

  private void searchresult_DoubleClick(object sender, EventArgs e)
  {
      if (this.SelectedItem != null)
      {
          DialogResult = DialogResult.OK;
          Close();
      }
  }

  public object SelectedItem { get { return search.result.SelectedItem; } }

  public SearchControl.FormatDelegate Format { set { search.Format = value; } }

}
