﻿using System.Windows.Forms;
using Plux;
using Plux.Framework;

//[Extension]
[Plug("Plux.View")]
[ParamValue("Name", "Usage statistics")]
[ParamValue("OrderIndex", 0.7f)]
[ParamValue("Tag", "USAGESTATISTICS")]
[Slot("LayoutManager", Unique = true,
  OnPlugged = "LayoutManager_Plugged", OnUnplugged = "LayoutManager_Unplugged")]
[Slot("Plux.Control", AutoRegister = false, AutoPlug=false, Unique=true,
  Multiple = true)]
[Slot("ScriptExecutor", OnPlugged = "ScriptExecutor_Plugged")]
public class Sidebar2 : UserControl, IView {
  private IScriptExecutor executor;
  private ILayoutManager layout;
  private ScriptReader reader;
  #region IView Members
  public Control Control {
    get { return this; }
  }
  #endregion

  private delegate void StringParameterHandler(string value);
  public void ScriptExecutor_Plugged(object sender, PlugEventArgs args) {
    executor = args.Extension as IScriptExecutor;
    reader = new ScriptReader(executor, args.SlotInfo.ExtensionInfo);
    Runtime.TaskQueue.InvokeOnEmptied(
      new StringParameterHandler(reader.ExecuteScript), "Sidebar2_Created.scr");
  }
  public void LayoutManager_Plugged(object s, PlugEventArgs args) {
    layout = args.Extension as ILayoutManager;
    layout.Init(this, Runtime.GetSlotInfo(this, "Plux.Control"));
    layout.SetLayoutStyle(LayoutStyles.RowLayout);
  }
  public void LayoutManager_Unplugged(object sender, PlugEventArgs args) {
    SlotInfo panelSlot = Runtime.GetSlotInfo(this, "Plux.Control");
    foreach(PlugInfo plug in panelSlot.PluggedPlugInfos) {
      IControl panel =
        (IControl) plug.ExtensionInfo.Object;
      panel.Control.Dock = DockStyle.Left;
      panel.Control.Width = 150;
    }
    layout = null;
  }
}